//
// Written by Sander van Rossen
//	You are free to use this piece of code any way you like
//
#pragma once


/*!
	@brief		Convert a number from a specified bit storage type to another 
				specified type with given source and destination offsets
*/
#define	ConvertBits(inSrcOffset, inSrcSize, inDstOffset, inDstSize, inType)		\
(																				\
	(																			\
		/* Shift it right by the source size (division)						*/	\
		(																		\
			(																	\
				(																\
					/* Get the source bits, remove all unused bits,			*/	\
					/* and shift the bits to the start of the integer		*/	\
					((inType) >> (inSrcOffset)) & ((1 << (inSrcSize))-1)		\
				/* Shift it left by the destination size (multiplication)	*/	\
				) << (inDstSize)												\
			) >> (inSrcSize)													\
		) +																		\
		/*																	*/	\
		/* This is to give the whole calculation more precision				*/	\
		/* without this a 15 (4-bit) would become 240 (8-bit)				*/	\
		/* instead of 255 (8-bit)											*/	\
		/*																	*/	\
		(																		\
			(																	\
				(																\
					/* Get the source bits, remove all unused bits,			*/	\
					/* and shift the bits to the start of the integer		*/	\
					((inType) >> (inSrcOffset)) & ((1 << (inSrcSize))-1)		\
				/* Shift it left by the destination size (multiplication)	*/	\
				) << (inDstSize)												\
			) >> (inSrcSize + inSrcSize)										\
		) +																		\
		/*																	*/	\
		/* This is to give the whole calculation even more precision		*/	\
		/* without this a 2 (1-bit) would become 252 (8-bit)				*/	\
		/* instead of 255 (8-bit)											*/	\
		/*																	*/	\
		(																		\
			(																	\
				(																\
					/* Get the source bits, remove all unused bits,			*/	\
					/* and shift the bits to the start of the integer		*/	\
					((inType) >> (inSrcOffset)) & ((1 << (inSrcSize))-1)		\
				/* Shift it left by the destination size (multiplication)	*/	\
				) << (inDstSize)												\
			) >> (inSrcSize + inSrcSize + inSrcSize)							\
		) +																		\
		/*																	*/	\
		/* This is to give the whole calculation even more precision		*/	\
		/* without this a 1 (1-bit) would become 224 (8-bit)				*/	\
		/* instead of 255 (8-bit)											*/	\
		/*																	*/	\
		(																		\
			(																	\
				(																\
					/* Get the source bits, remove all unused bits,			*/	\
					/* and shift the bits to the start of the integer		*/	\
					((inType) >> (inSrcOffset)) & ((1 << (inSrcSize))-1)		\
				/* Shift it left by the destination size (multiplication)	*/	\
				) << (inDstSize)												\
			) >> (inSrcSize + inSrcSize + inSrcSize + inSrcSize)				\
		)																		\
	/* Cap the value to the destination bits								*/	\
	)  & ((1 << (inDstSize))-1)													\
/* Shift it left to the destination position								*/	\
) << (inDstOffset)																\
//endof	ConvertBits(inSrcOffset, inSrcSize, inDstOffset, inDstSize, inType
